/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Objects;

/**
 * Provider
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class Provider {
  @SerializedName("id")
  private BigDecimal id = null;

  @SerializedName("location")
  private Model10 location = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("kind")
  private String kind = null;

  @SerializedName("speciality")
  private String speciality = null;

  @SerializedName("international_phone_number")
  private String internationalPhoneNumber = null;

  @SerializedName("website")
  private String website = null;

  @SerializedName("phone_admission")
  private String phoneAdmission = null;

  @SerializedName("email")
  private String email = null;

  @SerializedName("international_fax_number")
  private String internationalFaxNumber = null;

  @SerializedName("address")
  private Model11 address = null;

  @SerializedName("AXA_preferred")
  private Boolean axAPreferred = null;

  @SerializedName("AXA_direct_settlement")
  private Boolean axADirectSettlement = null;

  @SerializedName("payment_method")
  private String paymentMethod = null;

  @SerializedName("spoken_languages")
  private String spokenLanguages = null;

  @SerializedName("opening_hours")
  private String openingHours = null;

  @SerializedName("on_site_visit")
  private Boolean onSiteVisit = null;

  @SerializedName("gender")
  private String gender = null;

  @SerializedName("number_of_beds")
  private BigDecimal numberOfBeds = null;

  public Provider id(BigDecimal id) {
    this.id = id;
    return this;
  }

   /**
   * id of this provider
   * @return id
  **/
  @ApiModelProperty(required = true, value = "id of this provider")
  public BigDecimal getId() {
    return id;
  }

  public void setId(BigDecimal id) {
    this.id = id;
  }

  public Provider location(Model10 location) {
    this.location = location;
    return this;
  }

   /**
   * Get location
   * @return location
  **/
  @ApiModelProperty(value = "")
  public Model10 getLocation() {
    return location;
  }

  public void setLocation(Model10 location) {
    this.location = location;
  }

  public Provider name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of this provider. Ex : \&quot;HOPITAL DE LA PITIE SALPETRIERE\&quot; 
   * @return name
  **/
  @ApiModelProperty(value = "Name of this provider. Ex : \"HOPITAL DE LA PITIE SALPETRIERE\" ")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Provider kind(String kind) {
    this.kind = kind;
    return this;
  }

   /**
   * Kind of this provider. Ex: \&quot;hospital\&quot;, \&quot;doctor\&quot;, \&quot;dentist\&quot;, \&quot;pharmacy\&quot; 
   * @return kind
  **/
  @ApiModelProperty(value = "Kind of this provider. Ex: \"hospital\", \"doctor\", \"dentist\", \"pharmacy\" ")
  public String getKind() {
    return kind;
  }

  public void setKind(String kind) {
    this.kind = kind;
  }

  public Provider speciality(String speciality) {
    this.speciality = speciality;
    return this;
  }

   /**
   * Speciality of this provider. Ex: \&quot;Mammography, Laboratory, CT Scan, Ultrasound\&quot; 
   * @return speciality
  **/
  @ApiModelProperty(value = "Speciality of this provider. Ex: \"Mammography, Laboratory, CT Scan, Ultrasound\" ")
  public String getSpeciality() {
    return speciality;
  }

  public void setSpeciality(String speciality) {
    this.speciality = speciality;
  }

  public Provider internationalPhoneNumber(String internationalPhoneNumber) {
    this.internationalPhoneNumber = internationalPhoneNumber;
    return this;
  }

   /**
   * International phone number of this provider. Ex : \&quot;+33 1 42 16 00 00\&quot; 
   * @return internationalPhoneNumber
  **/
  @ApiModelProperty(value = "International phone number of this provider. Ex : \"+33 1 42 16 00 00\" ")
  public String getInternationalPhoneNumber() {
    return internationalPhoneNumber;
  }

  public void setInternationalPhoneNumber(String internationalPhoneNumber) {
    this.internationalPhoneNumber = internationalPhoneNumber;
  }

  public Provider website(String website) {
    this.website = website;
    return this;
  }

   /**
   * Website of this provider. Ex : \&quot;http://pitiesalpetriere.aphp.fr\&quot; 
   * @return website
  **/
  @ApiModelProperty(value = "Website of this provider. Ex : \"http://pitiesalpetriere.aphp.fr\" ")
  public String getWebsite() {
    return website;
  }

  public void setWebsite(String website) {
    this.website = website;
  }

  public Provider phoneAdmission(String phoneAdmission) {
    this.phoneAdmission = phoneAdmission;
    return this;
  }

   /**
   * Admission phone number of this provider. Ex : \&quot;+33 1 42 16 00 00\&quot; 
   * @return phoneAdmission
  **/
  @ApiModelProperty(value = "Admission phone number of this provider. Ex : \"+33 1 42 16 00 00\" ")
  public String getPhoneAdmission() {
    return phoneAdmission;
  }

  public void setPhoneAdmission(String phoneAdmission) {
    this.phoneAdmission = phoneAdmission;
  }

  public Provider email(String email) {
    this.email = email;
    return this;
  }

   /**
   * Email of this provider. Ex : \&quot;awesome@provider.com\&quot; 
   * @return email
  **/
  @ApiModelProperty(value = "Email of this provider. Ex : \"awesome@provider.com\" ")
  public String getEmail() {
    return email;
  }

  public void setEmail(String email) {
    this.email = email;
  }

  public Provider internationalFaxNumber(String internationalFaxNumber) {
    this.internationalFaxNumber = internationalFaxNumber;
    return this;
  }

   /**
   * International FAX number of this provider. Ex : \&quot;+33 1 42 17 60 06\&quot; 
   * @return internationalFaxNumber
  **/
  @ApiModelProperty(value = "International FAX number of this provider. Ex : \"+33 1 42 17 60 06\" ")
  public String getInternationalFaxNumber() {
    return internationalFaxNumber;
  }

  public void setInternationalFaxNumber(String internationalFaxNumber) {
    this.internationalFaxNumber = internationalFaxNumber;
  }

  public Provider address(Model11 address) {
    this.address = address;
    return this;
  }

   /**
   * Get address
   * @return address
  **/
  @ApiModelProperty(value = "")
  public Model11 getAddress() {
    return address;
  }

  public void setAddress(Model11 address) {
    this.address = address;
  }

  public Provider axAPreferred(Boolean axAPreferred) {
    this.axAPreferred = axAPreferred;
    return this;
  }

   /**
   * AXA preferred flag for this provider. Ex : true 
   * @return axAPreferred
  **/
  @ApiModelProperty(value = "AXA preferred flag for this provider. Ex : true ")
  public Boolean isAxAPreferred() {
    return axAPreferred;
  }

  public void setAxAPreferred(Boolean axAPreferred) {
    this.axAPreferred = axAPreferred;
  }

  public Provider axADirectSettlement(Boolean axADirectSettlement) {
    this.axADirectSettlement = axADirectSettlement;
    return this;
  }

   /**
   * AXA direct settlement flag for this provider. Ex : true 
   * @return axADirectSettlement
  **/
  @ApiModelProperty(value = "AXA direct settlement flag for this provider. Ex : true ")
  public Boolean isAxADirectSettlement() {
    return axADirectSettlement;
  }

  public void setAxADirectSettlement(Boolean axADirectSettlement) {
    this.axADirectSettlement = axADirectSettlement;
  }

  public Provider paymentMethod(String paymentMethod) {
    this.paymentMethod = paymentMethod;
    return this;
  }

   /**
   * Payment method for this provider. Ex : \&quot;Cash, Bank transfer, Any other form, VISA\&quot; 
   * @return paymentMethod
  **/
  @ApiModelProperty(value = "Payment method for this provider. Ex : \"Cash, Bank transfer, Any other form, VISA\" ")
  public String getPaymentMethod() {
    return paymentMethod;
  }

  public void setPaymentMethod(String paymentMethod) {
    this.paymentMethod = paymentMethod;
  }

  public Provider spokenLanguages(String spokenLanguages) {
    this.spokenLanguages = spokenLanguages;
    return this;
  }

   /**
   * Spoken language of this provider. Ex : \&quot;Arabic, English, French\&quot; 
   * @return spokenLanguages
  **/
  @ApiModelProperty(value = "Spoken language of this provider. Ex : \"Arabic, English, French\" ")
  public String getSpokenLanguages() {
    return spokenLanguages;
  }

  public void setSpokenLanguages(String spokenLanguages) {
    this.spokenLanguages = spokenLanguages;
  }

  public Provider openingHours(String openingHours) {
    this.openingHours = openingHours;
    return this;
  }

   /**
   * Spoken language of this provider. Ex : \&quot;\&quot; 
   * @return openingHours
  **/
  @ApiModelProperty(value = "Spoken language of this provider. Ex : \"\" ")
  public String getOpeningHours() {
    return openingHours;
  }

  public void setOpeningHours(String openingHours) {
    this.openingHours = openingHours;
  }

  public Provider onSiteVisit(Boolean onSiteVisit) {
    this.onSiteVisit = onSiteVisit;
    return this;
  }

   /**
   * On site visit for this provider. Ex : true 
   * @return onSiteVisit
  **/
  @ApiModelProperty(value = "On site visit for this provider. Ex : true ")
  public Boolean isOnSiteVisit() {
    return onSiteVisit;
  }

  public void setOnSiteVisit(Boolean onSiteVisit) {
    this.onSiteVisit = onSiteVisit;
  }

  public Provider gender(String gender) {
    this.gender = gender;
    return this;
  }

   /**
   * Gender of this provider. Ex : \&quot;Noperson\&quot; 
   * @return gender
  **/
  @ApiModelProperty(value = "Gender of this provider. Ex : \"Noperson\" ")
  public String getGender() {
    return gender;
  }

  public void setGender(String gender) {
    this.gender = gender;
  }

  public Provider numberOfBeds(BigDecimal numberOfBeds) {
    this.numberOfBeds = numberOfBeds;
    return this;
  }

   /**
   * Number of beds of this provider. Ex : 1594 
   * @return numberOfBeds
  **/
  @ApiModelProperty(value = "Number of beds of this provider. Ex : 1594 ")
  public BigDecimal getNumberOfBeds() {
    return numberOfBeds;
  }

  public void setNumberOfBeds(BigDecimal numberOfBeds) {
    this.numberOfBeds = numberOfBeds;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Provider provider = (Provider) o;
    return Objects.equals(this.id, provider.id) &&
        Objects.equals(this.location, provider.location) &&
        Objects.equals(this.name, provider.name) &&
        Objects.equals(this.kind, provider.kind) &&
        Objects.equals(this.speciality, provider.speciality) &&
        Objects.equals(this.internationalPhoneNumber, provider.internationalPhoneNumber) &&
        Objects.equals(this.website, provider.website) &&
        Objects.equals(this.phoneAdmission, provider.phoneAdmission) &&
        Objects.equals(this.email, provider.email) &&
        Objects.equals(this.internationalFaxNumber, provider.internationalFaxNumber) &&
        Objects.equals(this.address, provider.address) &&
        Objects.equals(this.axAPreferred, provider.axAPreferred) &&
        Objects.equals(this.axADirectSettlement, provider.axADirectSettlement) &&
        Objects.equals(this.paymentMethod, provider.paymentMethod) &&
        Objects.equals(this.spokenLanguages, provider.spokenLanguages) &&
        Objects.equals(this.openingHours, provider.openingHours) &&
        Objects.equals(this.onSiteVisit, provider.onSiteVisit) &&
        Objects.equals(this.gender, provider.gender) &&
        Objects.equals(this.numberOfBeds, provider.numberOfBeds);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, location, name, kind, speciality, internationalPhoneNumber, website, phoneAdmission, email, internationalFaxNumber, address, axAPreferred, axADirectSettlement, paymentMethod, spokenLanguages, openingHours, onSiteVisit, gender, numberOfBeds);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Provider {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    location: ").append(toIndentedString(location)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    kind: ").append(toIndentedString(kind)).append("\n");
    sb.append("    speciality: ").append(toIndentedString(speciality)).append("\n");
    sb.append("    internationalPhoneNumber: ").append(toIndentedString(internationalPhoneNumber)).append("\n");
    sb.append("    website: ").append(toIndentedString(website)).append("\n");
    sb.append("    phoneAdmission: ").append(toIndentedString(phoneAdmission)).append("\n");
    sb.append("    email: ").append(toIndentedString(email)).append("\n");
    sb.append("    internationalFaxNumber: ").append(toIndentedString(internationalFaxNumber)).append("\n");
    sb.append("    address: ").append(toIndentedString(address)).append("\n");
    sb.append("    axAPreferred: ").append(toIndentedString(axAPreferred)).append("\n");
    sb.append("    axADirectSettlement: ").append(toIndentedString(axADirectSettlement)).append("\n");
    sb.append("    paymentMethod: ").append(toIndentedString(paymentMethod)).append("\n");
    sb.append("    spokenLanguages: ").append(toIndentedString(spokenLanguages)).append("\n");
    sb.append("    openingHours: ").append(toIndentedString(openingHours)).append("\n");
    sb.append("    onSiteVisit: ").append(toIndentedString(onSiteVisit)).append("\n");
    sb.append("    gender: ").append(toIndentedString(gender)).append("\n");
    sb.append("    numberOfBeds: ").append(toIndentedString(numberOfBeds)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

